;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;stopwatch timer (xkas version), by GreenHammerBro
;
;Unlike imamelia's timer, this timer shows the minutes, seconds and the aproximate
;centisecond (one hundredth of a second) on the HUD (heads-up display) or status bar.
;It shows the timer in this format: "MM:SS.CC". If you want this to carry over to
;sublevels, use a ram address that don't reset on level load. Not to mention, this
;is a generator, not a sprite.

;Insert this using Asar in romi's spritetool! why? because I hate using the messy
;rep-1 macros for a simple if statement. To do that, replace xkas in the sprite tool
;folder with asar and rename asar "xkas.exe", Or move this to uberasm. Then run the
;software. Please don't ask me to convert this into an xkas sprite.

;Where the timer is position on the HUD:


!StatusBarFormat	= $02
 ;^*$01 = 1-byte per 8x8: TTTTTTTT (and repeats, this is smw's normal status bar)
 ; *$02 = 2-bytes per 8x8: TTTTTTTT YXPCCCTT (and repeats, for super status bar patch.)
 ;
 ;Note that Minimalist Status Bars uses a format where all tile numbers are grouped
 ;together and properties are in a seperate group, so use $01.

!HUD_Position		= $7FA000	;>Normal status bar position (any status bar type)
!screen_num		= $00		;>The screen number the timer uses to teleport the player when counting down.

;^Note about the screen number is that if you have this stopwatch in multiple levels,
;you have to set the level destination in each of them.

;Each freeram below is 1 byte:

!Freeram_Frame		= $60	;>this will be converted x/60 to y/100.
!Freeram_Second		= $61
!Freeram_Minute		= $62
!Freeram_TmrMode	= $63
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Code start
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
print "INIT ",pc	;\Not needed if uberasm
	RTL		;/
print "MAIN ",pc	;>not needed if uberasm
	PHB		;\Keep the preservation to prevent glitchy table index
	PHK		;|from being loaded from the rom.
	PLB		;/
	JSR Timer
	JSR HUDWrite
	PLB		;>and done with preserving
	RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Timer:
	LDA $9D		;>If locked flag set.
	ORA $1493	;>If mario is doing the goal walk...
;	ORA $13D4	;>(if you are using uberasm, remove ";", since it runs during pause)
;	ORA $xxxxxx	;>add a ram here if you want another ram to freeze the timer.
	BNE .Return	;>if at least 1 of the items is set, return
	LDA $0100	;\So that the timer doesn't change during level loading.
	CMP #$14	;|
	BNE .Return	;/

	LDA !Freeram_TmrMode	;\Mode determines the behavor of the timer.
	BEQ .Return		;|(Not based on position, but uses a block)
	CMP #$01		;|#$01 = count up.
	BEQ .CountUp		;|#$02 = count down has been ended
	CMP #$03		;|#$03 and up = countdown.
	BCS .CountDown		;/
.Return
	RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.CountUp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	LDA !Freeram_Frame	;\If frame counter hits 60, then increment seconds
	INC A			;|(the game runs at 60Hz or FPS)
	CMP.b #60		;|
	BEQ .IncrementSeconds	;/
	STA !Freeram_Frame
	RTS
.IncrementSeconds
	LDA #$00		;\Frame counter loops/wraps/MOD60
	STA !Freeram_Frame	;/to zero.
	LDA !Freeram_Second	;\If seconds reaches 60, increment minute
	INC A			;|
	CMP.b #60		;|
	BEQ .IncrementMinute	;/
	STA !Freeram_Second
	RTS
.IncrementMinute
	LDA #$00		;\Seconds loops/wraps/MOD60
	STA !Freeram_Second	;/to zero.
	LDA !Freeram_Minute	;\If minutes greater than or equal 60, then cap it
	INC A			;|(better than checking if all in each increment is
	CMP.b #60		;|59)
	BCS .CapTimer		;/
	STA !Freeram_Minute
	RTS
.CapTimer
	LDA.b #59		;\Lock the timer
	STA !Freeram_Frame	;|
	STA !Freeram_Second	;|
	STA !Freeram_Minute	;/
	RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.CountDown
;You might be wondering, why branch when its -1 rather than 0? Thats because for
;frames and seconds ranges from 0 to 59 (inclusive, 60 different values in between)
;is the valid value for a timer. Otherwise if its 1 to 59, thats 1 frame short,
;which the timer is a bit faster than the real world's one. After all, 1 second and
;0 frames exactly equals 1 whole second.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	LDA !Freeram_Frame	;\if all zero
	ORA !Freeram_Second	;|then trigger event
	ORA !Freeram_Minute	;|
	BEQ .AllZero		;/

	LDA !Freeram_Frame	;\If frame decrements below 0, then
	DEC A			;|decrement seconds.
	BMI .DecrementSeconds	;/
	STA !Freeram_Frame
	RTS
.DecrementSeconds
	LDA.b #59		;\frame counter: 02, 01, 00, 59...
	STA !Freeram_Frame	;/
	LDA !Freeram_Second	;\If seconds goes below 0
	DEC A			;|then decrement minutes
	BMI .DecrementMinutes	;/
	STA !Freeram_Second	;
	RTS
.DecrementMinutes
	LDA.b #59		;\seconds: 02, 01, 00, 59...
	STA !Freeram_Second	;/
	LDA !Freeram_Minute	;\Don't worry, there is a check above to prevent negative time.
	DEC A			;/
	STA !Freeram_Minute
.CountDownEnd
	RTS
.AllZero
	LDA !Freeram_TmrMode	;\Thanks Ladida and Vitor Vilela for the pointer
	ASL			;|subroutine!
	TAX			;|
	BCS .LargeTbl		;|
	JMP.w (Events,x)	;|
.LargeTbl			;|
	JMP.w (Events+256,x)	;/

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Here is the list of events you want to happen after the timer counts down to zero.
;indexs #$00~#$02 are not used since they are reserved for nothing and during
;counting.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Events:			;index number:
	dw .Notused	;>#$00 (disabled)
	dw .Notused	;>#$01 (count up)
	dw .Notused	;>#$02 (countdown ended)
	dw .KillMario	;>#$03 (countdown, kill)
	dw .Teleport	;>#$04 (countdown, teleport)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Pointer's code. Make sure you add "LDA #$02 : STA !Freeram_TmrMode" before each
;and every RTS here so that it executes once.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.Notused
	RTS
.KillMario
	LDA #$02		;\Don't trigger multiple times.
	STA !Freeram_TmrMode	;/
	JSL $00F606		;>kill the player.
	RTS
.Teleport
	LDA #$02		;\Don't trigger multiple times.
	STA !Freeram_TmrMode	;/
	LDA $5B			;\Switch screen type if vertical level.
	AND #$01		;|
	ASL 			;|
	TAX 			;|
	LDA $95,x		;|
	TAX			;/

	LDA $19B8+!screen_num	;\adjust what screen exit to use for
	STA $19B8,x		;|teleporting.
	LDA $19D8+!screen_num	;|
	STA $19D8,x		;/
	
	LDA #$06 		;\Teleport the player.
	STA $71  		;|
	STZ $88			;|
	STZ $89			;/
	RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Write on status bar/HUD
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HUDWrite:
	LDA !Freeram_TmrMode	;\It timer set to count down, then write
	CMP #$02		;|
	BCS .Write		;/
	LDA !Freeram_Frame	;\If the timer is all zero, then don't write.
	ORA !Freeram_Second	;|
	ORA !Freeram_Minute	;|
	BNE .Write		;/
	RTS			
.Write

	LDA !Freeram_Minute
	JSR HexDec

;Display minutes on HUD:
	STA !HUD_Position+($01*!StatusBarFormat)	;>Ones
	TYA						;>STY $xxxxxx does not exist.
	STA !HUD_Position				;>Tens
	LDA #$78					;\":"
	STA !HUD_Position+($02*!StatusBarFormat)	;/
	LDA !Freeram_Second				;\Convert value to decimal numbers on the status bar.
	JSR HexDec					;/

;Display seconds on HUD:
	STA !HUD_Position+($04*!StatusBarFormat)	;>Ones
	TYA						;>Again, there are no long addressing for STY
	STA !HUD_Position+($03*!StatusBarFormat)	;>Tens
	LDA #$24					;\"."
	STA !HUD_Position+($05*!StatusBarFormat)	;/
	LDA !Freeram_Frame				;\This is so that when the timer reaches the maximum when
	CMP.b #59					;|counting upwards, does not show 59:59.98, but shows
	BNE .NotAll59					;|59:59.99 instead.
	LDA !Freeram_Second				;|
	CMP.b #59					;|
	BNE .NotAll59					;|
	LDA !Freeram_Minute				;|
	CMP.b #59					;|
	BNE .NotAll59					;/

	LDA.b #99
	BRA .WriteCentisecond

.NotAll59
;---------------------------------------------
;This is how I convert x/60 to y/100:
;Solve for y:
;
;	x     y
;	__  = ___
;	60    100
;I do cross multiply:
;
;	100x = 60y
;	____   ___
;	60     60
;
;so (X*100)/60 = y.
;---------------------------------------------
;Write approx centiseconds on HUD.
;Multiply			;>credit goes to wiiqwertyuiop and GreenHammerBro (fix the issue with X*(Y+1))
	REP #$20			;>if you mutiply 59 by 100 and it exceeds 255, then 16-bit is needed.
	LDA.w !Freeram_Frame		;\multiplication routine, multiply by 100
	AND #$00FF			;|>Get rid of high byte
	STA $00				;|
	LDA.w #100			;|
	STA $02				;|
	STA $04				;|
-	LSR $02				;|
	BEQ .end			;|
	BCC +				;|
	CLC				;|
	ADC $00				;|
+	ASL $00				;|
	BRA -				;|
.end					;|
	CLC				;|
	ADC $00				;|
	SEC				;|\remove 1-extra multiplication.
	SBC $04				;//

	STA $00				;\Divide by 60
	LDA.w #60			;|
	STA $02				;|
	PHB				;|
	PHK				;|
	PLB				;|
	JSR MathDiv			;|
	PLB				;/
	SEP #$20
	LDA $02				;\Round 1/2 way up if the modulo (Remainder) is
	CMP.b #50			;|greater than or equal to 50 (half of a second).
	BCS .RoundHalfUp		;/
	LDA $00				;\Otherwise round down.
	BRA .WriteCentisecond		;/
.RoundHalfUp
	LDA $00
	INC A
.WriteCentisecond
	JSR HexDec			;>Convert value to decimal numbers on the status bar.
;Write centiseconds:
	STA !HUD_Position+($07*!StatusBarFormat)	;>Ones
	TYA
	STA !HUD_Position+($06*!StatusBarFormat)	;>Tens
	RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HexDec:
	LDY #$00	;>Y is the tens place, A is the ones.
.Loops
	CMP #$0A	;>This is the modulo 10 (digits are 0-9)
	BCC .Return
	SBC #$0A
	INY
	BRA .Loops
.Return
	RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 16bit / 16bit Division
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Arguments
; $00-$01 : Dividend
; $02-$03 : Divisor
; Return values
; $00-$01 : Quotient
; $02-$03 : Remainder
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MathDiv:	REP #$20
		ASL $00
		LDY #$0F
		LDA.w #$0000
-		ROL A
		CMP $02
		BCC +
		SBC $02
+		ROL $00
		DEY
		BPL -
		STA $02
		SEP #$20
		RTS